<div align="center">

# Welcome to Modern JS Boilerplate <img src="https://media.giphy.com/media/hvRJCLFzcasrR4ia7z/giphy.gif" width="25px">

<p>

![Version](https://img.shields.io/npm/v/modern-js-boilerplate)
![Size](https://img.shields.io/github/repo-size/Rajaniraiyn/modern-js-boilerplate)
<a href="https://github.com/Rajaniraiyn/modern-js-boilerplate#readme" target="_blank">
![Documentation](https://img.shields.io/badge/documentation-yes-brightgreen.svg)
</a>
<a href="https://github.com/Rajaniraiyn/modern-js-boilerplate/graphs/commit-activity" target="_blank">
![Maintenance](https://img.shields.io/badge/Maintained%3F-yes-green.svg)
</a>
<a href="https://github.com/Rajaniraiyn/modern-js-boilerplate/blob/master/LICENSE" target="_blank">
![License: MIT](https://img.shields.io/github/license/Rajaniraiyn/modern-js-boilerplate)
</a>
![Dependabot](https://badgen.net/github/dependabot/Rajaniraiyn/modern-js-boilerplate)

</p>

A simple js module boilerplate with all modern technologies

| Table of contents                                                                                                                                                                                                                                                       |
| ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| [Features](#features)                                                                                                                                                                                                                                                   |
| [Usage](#usage)                                                                                                                                                                                                                                                         |
| [📜 Documentation](#-documentation) <br/> <br/> _[Build for development](#build-for-development) <br/> [Build for production](#build-for-production) <br/> [Cleaning](#cleaning) <br/> [Linting](#linting) <br/> [Prettifying](#prettifying) <br/> [Testing](#testing)_ |
| [Stack](#stack)                                                                                                                                                                                                                                                         |
| [👨‍💻 Developer](#-developer)                                                                                                                                                                                                                                             |
| [For all Developers](#for-all-developers)                                                                                                                                                                                                                               |
| [🤝 Contributing](#-contributing)                                                                                                                                                                                                                                       |
| [🤝 Contributors](#-contributors)                                                                                                                                                                                                                                       |
| [Show your support](#show-your-support)                                                                                                                                                                                                                                 |
| [📝 License](#-license)                                                                                                                                                                                                                                                 |

</div>

## Features

- Modern
- Simple
- Supports ES6
- Advanced Optimizations
- Powerful git hooks and automated tasks
- Highly extensible
- Suitable for all
- Out of the box tree-shaking
- Minifies, compresses and mangles the production build

## Usage

- You need to have a machine installed with _[git](https://git-scm.com/)_ and _[node](https://nodejs.org/)_ (which has _[npm](https://www.npmjs.com/)_ included within it) use this boilerplate

```sh
git clone https://github.com/Rajaniraiyn/modern-js-boilerplate.git

cd modern-js-boilerplate

npm install
```

## 📜 Documentation

### Build for development

- Starts a local server at https://localhost:8080 with [HMR(Hot-Module-Replacement)](https://webpack.js.org/guides/hot-module-replacement/) using [webpack-dev-server](https://webpack.js.org/configuration/dev-server/) with [babel](https://babeljs.io/)

```sh
npm run dev
```

### Build for production

- Creates a minified and optimized code for production in _dist_ folder using [webpack](https://webpack.js.org/) with [babel](https://babeljs.io/) and [terser](https://terser.org/)

```sh
npm run build
```

### Cleaning

- Removes all files in _dist_ folder using rimraf

```sh
npm run clean
```

### Linting

- Lints all files in _src_ directory using [ESLint](https://eslint.org/) with Airbnb style

```sh
npm run lint
```

### Prettifying

- Lints the code then prettify the code using [prettier](https://prettier.io/)

```sh
npm run prettier
```

### Testing

- Tests according `my.test.js` using [jest](https://jestjs.io/)

```sh
npm run test
```

## Stack

|               [ES Lint](https://eslint.org/)                |               [Babel](https://babeljs.io/)                |                                        [jest](https://jestjs.io/)                                         |                                     [Prettier](https://prettier.io/)                                      |                [Terser](https://terser.org/)                |             [Webpack](https://webpack.js.org/)              |             [ Husky](https://typicode.github.io/husky/#/)              |
| :---------------------------------------------------------: | :-------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------: | :-------------------------------------------------------------------------------------------------------: | :---------------------------------------------------------: | :---------------------------------------------------------: | :--------------------------------------------------------------------: |
| ![ES Lint](https://avatars.githubusercontent.com/u/6019716) | ![Babel](https://avatars.githubusercontent.com/u/9637642) | ![Jest](https://github.com/facebook/jest/blob/main/website/static/img/favicon/android-chrome-512x512.png) | ![Prettier](https://github.com/prettier/prettier-logo/blob/master/images/prettier-icon-clean-centred.svg) | ![Terser](https://avatars.githubusercontent.com/u/43502240) | ![Webpack](https://avatars.githubusercontent.com/u/2105791) | ![Husky](https://images.opencollective.com/husky/7bdbfe1/logo/256.png) |

## 👨‍💻 Developer

**_Rajaniraiyn_**

- Website: https://rajaniraiyn.github.io/
- Github: [@rajaniraiyn](https://github.com/Rajaniraiyn)
- LinkedIn: [@rajaniraiyn](https://linkedin.com/in/rajaniraiyn)

## For all Developers

> If you optimize everything, you will always be unhappy. - _[Donald Knuth](https://en.wikipedia.org/wiki/Donald_Knuth)_

## 🤝 Contributing

Contributions, issues and feature requests are welcome!

Feel free to check [issues page](https://github.com/Rajaniraiyn/modern-js-boilerplate/issues). You can also take a look at the [contributing guide](CONTRIBUTING.md).

## 🤝 Contributors

<a href="https://github.com/rajaniraiyn/modern-js-boilerplate/graphs/contributors">
  
  ![contributors](https://contrib.rocks/image?repo=rajaniraiyn/modern-js-boilerplate)
  
</a>

## Show your support

Give a ⭐️ if this project helped you!

## 📝 License

Copyright © 2021 [Rajaniraiyn](https://github.com/Rajaniraiyn).

This project is [MIT](LICENSE) licensed.

---
